## ipxe 1.21.1+git-20250602.5b3ebf8b+dfsg

=== debian/changelog ===
ipxe (1.21.1+git-20250602.5b3ebf8b+dfsg-1ubuntu3) questing; urgency=medium

  * d/t/control: skip-not-installable rom-* tests (LP: #1677874)

 -- Lukas Märdian <slyon@ubuntu.com>  Mon, 29 Sep 2025 11:45:57 +0200

ipxe (1.21.1+git-20250602.5b3ebf8b+dfsg-1ubuntu2) questing; urgency=medium

  * d/p/respect-CPPFLAGS-CFLAGS-LDFLAGS-presets: removed due to upstream
    request (LP: #2121439)

 -- Jonas Jelten <jonas.jelten@canonical.com>  Wed, 10 Sep 2025 12:10:47 +0200

ipxe (1.21.1+git-20250602.5b3ebf8b+dfsg-1ubuntu1) questing; urgency=medium

  * Merge with Debian unstable (LP: #1996530). Changed version from debian's
    1.21.1+git20250602.5b3ebf8b+dfsg-1 by including '+git-', which is needed
    to be newer than Ubuntu's latest 1.21.1+git-20220113.fbbdc3926-0ubuntu2
    and newer than Debian's 1.21.1+git20250602.5b3ebf8b+dfsg-1 (using '+git')

    Remaining changes:
    - d/util/check-rom-sizes, d/rules: pad size of generated roms to 512KiB
      to avoid accidentally breaking KVM live migration on updates/fixes.
      debian managed to reduce the size back to 256KiB in
      1.21.1+git20250317.42a29d56+dfsg-1
      but to be future-proof, let's reserve this little extra space.
      background: qemu migrations apparently reserve memory from the target
      system's roms, while moving the data from the source emulator.
  * Drop changes:
    - Fix FTBFS with new binutils
      + d/p/0003-Inhibit-linker-warnings-about-an-implied-executable-.patch
      [upstream in e17568ad0642490143d0c6b154c874b9b9e285bf]
      + d/p/0004-Fix-building-with-newer-binutils.patch
      [upstream in 6ca597eee9f95b846a3c2dc1231e63cfc02272c1]
    - d/p/handle-dhcp-nack.patch: Handle DHCP NAK and send a re-discover.
      (LP #1707999)
      [upstream in 1192edf394aaebde666c6aafda1c8b782b08a845]
    - d/p/build-Be-explicit-about-fcommon-compiler-directive.patch
      [upstream in 1.21.0 f982a712979619dbae2c6e0d741757e2ce94be11]
    - d/p/lp-1882671-efi-Raise-TPL-during-driver-entry-point.patch
      (LP #1882671)
      [upstream in 1.21.0 2ae5d4338661b65c63eb5cb1a96e5b803fe7d620]
    - split grub integration from ipxe->grub-ipxe
      [included in 1.21.1+git20220113.fbbdc3926+dfsg-3]
    - d/grub-ipxe.install, d/control, d/rules: Build ipxe-arm64.efi
      (LP #1890230)
      [included in 1.21.1+git20220113.fbbdc3926+dfsg-3]
    - d/rules: build ROMs for QEMU with CONFIG=qemu
      (LP #1789319)
      [included in 1.21.1+git20220113.fbbdc3926+dfsg-2]
    - d/tree/ipxe/etc/grub.d/20_ipxe: Make grub-ipxe work under UEFI
      (LP #1811496)
      [included in 1.21.1+git20220113.fbbdc3926+dfsg-2]
    - d/rules: don't clean explicitly in between builds
      [included in 1.21.1+git20220113.fbbdc3926+dfsg-2]
    - d/util/geniso: fix rounding to unbreak iso creation
      [included in 1.21.1+git20220113.fbbdc3926+dfsg-1]
    - d/copyright updates (LP #1747071)
      [included in 1.21.1+git20220113.fbbdc3926+dfsg-1]
    - d/p/0005-strip-802.1Q-VLAN-0-priority-tags.patch
      [included in 1.21.1+git20220113.fbbdc3926+dfsg-1]
  * New changes:
    - d/watch: use format $version+git-$date-$hash
      to ensure version continuity, since debian switched to
      $version+git$date-$hash which is lower than -
    - d/p/debian/patches/respect-CPPFLAGS-CFLAGS-LDFLAGS-presets.patch:
      fix HOST_CFLAGS recursion to avoid make error
      "Recursive variable `HOST_CFLAGS' references itself"
    - d/rules: don't build with lto (as recommended by upstream)
      https://github.com/ipxe/ipxe/issues/1515

 -- Jonas Jelten <jonas.jelten@canonical.com>  Wed, 13 Aug 2025 12:18:36 +0200

=== debian/control ===
Source: ipxe
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Miao Wang <shankerwangmiao@gmail.com>
Uploaders: Shengqi Chen <harry@debian.org>
Build-Depends:
    debhelper-compat (= 13),
    dh-exec,
    liblzma-dev:native,
    xxd,
    zlib1g-dev:native,
    expect <!nocheck>,
Build-Depends-Indep:
    dosfstools:native,
    gcc-x86-64-linux-gnu,
    gcc-aarch64-linux-gnu,
    gcc-loongarch64-linux-gnu,
    gcc-riscv64-linux-gnu,
    isolinux,
    mtools,
    syslinux-common,
    xorriso,
    seabios <!nocheck>,
    ovmf <!nocheck>,
    qemu-efi-aarch64 <!nocheck>,
    qemu-efi-riscv64 <!nocheck>,
    qemu-efi-loongarch64 <!nocheck>,
    qemu-system-i386 <!nocheck>,
    qemu-system-amd64 <!nocheck>,
    qemu-system-arm64 <!nocheck>,
    qemu-system-riscv64 <!nocheck>,
    qemu-system-loong64 <!nocheck>,
Build-Depends-Arch:
    seabios [i386 amd64] <!nocheck>,
    ovmf [amd64] <!nocheck>,
    qemu-system-i386 [i386] <!nocheck>,
    qemu-system-amd64 [amd64] <!nocheck>,
    qemu-efi-aarch64 [arm64] <!nocheck>,
    qemu-system-arm64 [arm64] <!nocheck>,
    qemu-efi-riscv64 [riscv64] <!nocheck>,
    qemu-system-riscv64 [riscv64] <!nocheck>,
    qemu-efi-loongarch64 [loong64] <!nocheck>,
    qemu-system-loong64 [loong64] <!nocheck>,
    dosfstools:native <!nocheck>,
    mtools <!nocheck>,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://ipxe.org/
Vcs-Git: https://salsa.debian.org/debian/ipxe.git
Vcs-Browser: https://salsa.debian.org/debian/ipxe

Package: ipxe
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Recommends: grub-ipxe
Description: PXE boot firmware
 iPXE is network boot firmware.  It supports a variety of network cards,
 including some wireless cards, and variety of network protocols (traditional
 DHCP, BOOTP and TFTP and also HTTP, iSCSI, SAN via FCoE and Infiniband). It
 supports scripting.
 .
 It is possible to use iPXE as a PXE ROM in the network card or to
 chainload it from other boot methods.
 .
 This package provides boot code for all supported network cards in one
 binary and several bootable formats.

Package: ipxe-qemu
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Description: PXE boot firmware - ROM images for qemu
 iPXE is network boot firmware.  It supports a variety of network cards,
 including some wireless cards, and variety of network protocols (traditional
 DHCP, BOOTP and TFTP and also HTTP, iSCSI, SAN via FCoE and Infiniband). It
 supports scripting.
 .
 It is possible to use iPXE as a PXE ROM in the network card or to
 chainload it from other boot methods.
 .
 This package provides boot code for the qemu emulated network cards
 as boot ROMs.


Package: grub-ipxe
Architecture: i386 amd64 arm64 riscv64 loong64
Suggests: grub2-common
Depends: ${misc:Depends}
Breaks: ipxe (<< 1.21.1+git20220113.fbbdc3926+dfsg-3)
Replaces: ipxe (<< 1.21.1+git20220113.fbbdc3926+dfsg-3)
Description: Network booting using iPXE
 iPXE is network boot firmware.  It supports a variety of network cards,
 including some wireless cards, and variety of network protocols (traditional
 DHCP, BOOTP and TFTP and also HTTP, iSCSI, SAN via FCoE and Infiniband). It
 supports scripting.
 .
 This package contains bootable iPXE images and adds a menu entry to grub2 for
 network booting using iPXE.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@

# qemu EFI roms shall be built with CONFIG=qemu
# This makes it apply src/config/*, src/config/qemu/*, src/config/local/*,
# src/config/local/qemu/* in this order.
src/bin-%.rom src/bin-%.efirom: export CONFIG=qemu

# Export CROSS prefix for building.
# This controls the architecture-specific build tools to be used.
src/bin-i386-pcbios%: export CROSS=x86_64-linux-gnu-
src/bin-i386-pcbios%: export DEB_HOST_ARCH=amd64

src/bin-x86_64-efi%: export CROSS=x86_64-linux-gnu-
src/bin-x86_64-efi%: export DEB_HOST_ARCH=amd64

src/bin-arm64-efi%: export CROSS=aarch64-linux-gnu-
src/bin-arm64-efi%: export DEB_HOST_ARCH=arm64

src/bin-riscv64-efi%: export CROSS=riscv64-linux-gnu-
src/bin-riscv64-efi%: export DEB_HOST_ARCH=riscv64

src/bin-loong64-efi%: export CROSS=loongarch64-linux-gnu-
src/bin-loong64-efi%: export DEB_HOST_ARCH=loong64

# For i386, use the i686-linux-gnu- toolchain when x86_64-linux-gnu- is not
# available. This is the case when building any package for i386 host.
ifeq ($(DEB_HOST_ARCH),i386)
ifneq ($(shell dpkg-query --show --showformat '$${db:Status-Status}' gcc-x86-64-linux-gnu),installed)
src/bin-i386-pcbios%: export CROSS=i686-linux-gnu-
src/bin-i386-pcbios%: export DEB_HOST_ARCH=i386
endif
endif

ifeq ($(DEB_BUILD_ARCH),i386)
export HOST_EFI_CFLAGS = -malign-double
endif

# used in (patched) src/Makefile
export HOST_CFLAGS = $(shell dpkg-buildflags --get CFLAGS_FOR_BUILD) $(shell dpkg-buildflags --get LDFLAGS_FOR_BUILD) -D__BLHC_IGNORE_HOSTCC

# 1. forcibly use cross tools and ignore DEB_HOST_ARCH
# 2. also setting CXX and PKG_CONFIG even if they are not used
#    to avoid confusing names in build logs
# 3. XFLAGS from env cannot be reused since DEB_HOST_ARCH is reset
# 4. save the files that are modified by the build, restore them when
#    next build of the same <arch>-<platform> is triggered, to prevent
#    unnecessary rebuilds
define run-dh_auto_build =
if [ -e "$(dir $@)/config.tar" ]; then \
	tar -C src -xf "$(dir $@)/config.tar"; \
fi
@if [ "$$DEB_HOST_ARCH" != "$(DEB_BUILD_ARCH)" ]; then \
	echo "blhc: ignore-line-regexp: .*$$CROSS.*"; \
fi
CC="$${CROSS}gcc" \
CXX="$${CROSS}g++" \
PKG_CONFIG="$${CROSS}pkg-config" \
CFLAGS="$$(dpkg-buildflags --get CFLAGS)" \
CPPFLAGS="$$(dpkg-buildflags --get CPPFLAGS)" \
LDFLAGS="$$(dpkg-buildflags --get LDFLAGS)" \
dh_auto_build --sourcedirectory=src -- \
	V=1 NO_WERROR=1 VERSION="$(DEB_VERSION)" $(subst src/,,$@)
tar -C src -cf "$(dir $@)/config.tar" config/local config/named.h include/compiler.h include/ipxe/profile.h include/assert.h
endef

src/bin-i386-pcbios%:
	$(run-dh_auto_build)

src/bin-x86_64-efi%:
	$(run-dh_auto_build)

src/bin-arm64-efi%:
	$(run-dh_auto_build)

src/bin-riscv64-efi%:
	$(run-dh_auto_build)

src/bin-loong64-efi%:
	$(run-dh_auto_build)

# efi roms are >256k since Bionic due to https + natural growth
# stay at 256k-512k after disabling https in efi via padding
define run-catrom =
@mkdir -p $(dir $@)
@echo "Combining $@ with:"
@for rom in $^; do \
	echo "  $$rom: $$(stat -c %s "$$rom" )"; \
done
src/util/catrom.pl $^ > $@
@echo "Size before padding: $$(stat -c %s $@)"
src/util/padimg.pl --blksize=524288 --byte=0xff --verbose $@
endef

src/bin-combined/%.efirom: src/bin-i386-pcbios-rom/%.rom src/bin-x86_64-efi-rom/%.efirom
	$(run-catrom)

src/bin-combined/%.iso: src/bin-i386-pcbios/%.lkrn src/bin-x86_64-efi/%.efi src/bin-arm64-efi/%.efi src/bin-riscv64-efi/%.efi src/bin-loong64-efi/%.efi
	@mkdir -p $(dir $@)
	debian/util/geniso $@ $^

define get_targets
$(shell \
  for pkg in $$(dh_listpackages $(1)); do \
    if [ -e "debian/$$pkg.$(2)" ]; then \
	  ( \
		if [ -x "debian/$$pkg.$(2)" ]; then \
		  dh-exec --with= "debian/$$pkg.$(2)"; \
		else \
		  cat "debian/$$pkg.$(2)"; \
		fi \
	  ) | grep -hoE 'src/bin\S+'; \
	fi; \
  done \
)
endef

# ================
# dh targets below
# ================

execute_before_dh_auto_build:
	@echo "blhc: ignore-line-regexp: .*__BLHC_IGNORE_HOSTCC.*"

override_dh_auto_build-indep: $(call get_targets,-i,install)
override_dh_auto_build-arch: $(call get_targets,-a,install)

execute_after_dh_install-indep:
	debian/util/check-rom-sizes

override_dh_auto_clean:
	dh_auto_clean --sourcedirectory=src -- veryclean
	rm -fr src/bin-*
	find src/config/local -type f -name '*.h' -size 0 -delete

ifeq (,$(filter nocheck, $(DEB_BUILD_OPTIONS)))

test_roms-indep = $(call get_targets,-i,testroms)
test_roms-arch = $(call get_targets,-a,testroms)

override_dh_auto_build-indep: $(test_roms-indep)
override_dh_auto_build-arch: $(test_roms-arch)

debian/self_tests/%: %
	./debian/tests/ipxe-tests $<
	mkdir -p $(dir $@) && touch $@

override_dh_auto_test-indep: $(addprefix debian/self_tests/,$(test_roms-indep))
override_dh_auto_test-arch: $(addprefix debian/self_tests/,$(test_roms-arch))

override_dh_auto_clean: clean_self_tests
clean_self_tests:
	rm -rf debian/self_tests

endif

=== debian/tests/control ===
Test-Command: ./debian/tests/ipxe-iso i386 cd
Depends: ipxe, expect, xxd, qemu-system-amd64 [amd64 arm64 loong64 mips64el ppc64 ppc64el riscv64 s390x sparc64], qemu-system-i386 [armel armhf i386], seabios,
Features: test-name=iso-i386-cd
Architecture: amd64,arm64,loong64,mips64el,ppc64,ppc64el,riscv64,s390x,sparc64,armel,armhf,i386

Test-Command: ./debian/tests/ipxe-iso i386 hd
Depends: ipxe, expect, xxd, qemu-system-amd64 [amd64 arm64 loong64 mips64el ppc64 ppc64el riscv64 s390x sparc64], qemu-system-i386 [armel armhf i386], seabios,
Features: test-name=iso-i386-hd
Architecture: amd64,arm64,loong64,mips64el,ppc64,ppc64el,riscv64,s390x,sparc64,armel,armhf,i386

Test-Command: ./debian/tests/ipxe-iso x86_64 cd
Depends: ipxe, expect, xxd, qemu-system-amd64, ovmf,
Features: test-name=iso-x86_64-cd
Architecture: amd64,arm64,loong64,mips64el,ppc64,ppc64el,riscv64,s390x,sparc64

Test-Command: ./debian/tests/ipxe-iso x86_64 hd
Depends: ipxe, expect, xxd, qemu-system-amd64, ovmf,
Features: test-name=iso-x86_64-hd
Architecture: amd64,arm64,loong64,mips64el,ppc64,ppc64el,riscv64,s390x,sparc64

Test-Command: ./debian/tests/ipxe-iso arm64 cd
Depends: ipxe, expect, xxd, qemu-system-arm64, qemu-efi-aarch64,
Features: test-name=iso-arm64-cd
Architecture: amd64,arm64,loong64,mips64el,ppc64,ppc64el,riscv64,s390x,sparc64

Test-Command: ./debian/tests/ipxe-iso arm64 hd
Depends: ipxe, expect, xxd, qemu-system-arm64, qemu-efi-aarch64,
Features: test-name=iso-arm64-hd
Architecture: amd64,arm64,loong64,mips64el,ppc64,ppc64el,riscv64,s390x,sparc64

Test-Command: ./debian/tests/ipxe-iso riscv64 cd
Depends: ipxe, expect, xxd, qemu-system-riscv64, qemu-efi-riscv64,
Features: test-name=iso-riscv64-cd
Architecture: amd64,arm64,loong64,mips64el,ppc64,ppc64el,riscv64,s390x,sparc64

Test-Command: ./debian/tests/ipxe-iso riscv64 hd
Depends: ipxe, expect, xxd, qemu-system-riscv64, qemu-efi-riscv64,
Features: test-name=iso-riscv64-hd
Architecture: amd64,arm64,loong64,mips64el,ppc64,ppc64el,riscv64,s390x,sparc64

Test-Command: ./debian/tests/ipxe-iso loong64 cd
Depends: ipxe, expect, xxd, qemu-system-loong64, qemu-efi-loongarch64,
Features: test-name=iso-loong64-cd
Architecture: amd64,arm64,loong64,mips64el,ppc64,ppc64el,riscv64,s390x,sparc64

Test-Command: ./debian/tests/ipxe-iso loong64 hd
Depends: ipxe, expect, xxd, qemu-system-loong64, qemu-efi-loongarch64,
Features: test-name=iso-loong64-hd
Architecture: amd64,arm64,loong64,mips64el,ppc64,ppc64el,riscv64,s390x,sparc64

Test-Command: ./debian/tests/ipxe-rom i386 e1000
Depends: ipxe-qemu, expect, xxd, qemu-system-amd64 [amd64 arm64 loong64 mips64el ppc64 ppc64el riscv64 s390x sparc64], qemu-system-i386 [armel armhf i386], seabios, debian-installer-13-netboot-amd64,
Features: test-name=rom-i386-e1000
Restrictions: skip-not-installable
Architecture: amd64,arm64,loong64,mips64el,ppc64,ppc64el,riscv64,s390x,sparc64,armel,armhf,i386

Test-Command: ./debian/tests/ipxe-rom i386 e1000e

=== debian/watch ===
# +pre should be removed to be in sync with debian's versions
# once a newer upstream than 1.21.1 was released.
# we have to add +pre to be newer than ubuntu's latest release named
# 1.21.1+git-$date
# and newer than debian's latest release named
# 1.21.1+git$date
version=4
opts=\
	mode=git,\
	gitmode=full,\
	pretty=1.21.1+git-%cd.%h,\
	repacksuffix=+dfsg,\
	dversionmangle=s/\+dfsg\d*// \
https://github.com/ipxe/ipxe.git \
HEAD

## ipxe 1.21.1+git-20250829.969ce2c55+dfsg

=== debian/changelog ===
ipxe (1.21.1+git-20250829.969ce2c55+dfsg-1) unstable; urgency=medium

  [ Miao Wang ]
  * d/watch: change upstream versioning scheme (Closes: #1112218).
  * d/copyright: ignore .github/.
  * New upstream version 1.21.1+git-20250829.969ce2c55+dfsg.
  * d/control: remove ipxe Rec: grub-ipxe.
  * d/p: refresh patches.
  * d/ci: remove hacks.

  [ Shengqi Chen ]
  * d/watch: switch to uscan version 5.

 -- Shengqi Chen <harry@debian.org>  Wed, 17 Sep 2025 17:02:14 +0800

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: ipxe
 Section: admin
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Miao Wang <shankerwangmiao@gmail.com>
+Maintainer: Miao Wang <shankerwangmiao@gmail.com>
 Uploaders: Shengqi Chen <harry@debian.org>
 Build-Depends:
     debhelper-compat (= 13),
@@ -54,7 +53,6 @@
 Architecture: all
 Multi-Arch: foreign
 Depends: ${misc:Depends},
-Recommends: grub-ipxe
 Description: PXE boot firmware
  iPXE is network boot firmware.  It supports a variety of network cards,
  including some wireless cards, and variety of network protocols (traditional

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 #export DH_VERBOSE=1
 
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/default.mk
 
@@ -98,7 +98,7 @@
 done
 src/util/catrom.pl $^ > $@
 @echo "Size before padding: $$(stat -c %s $@)"
-src/util/padimg.pl --blksize=524288 --byte=0xff --verbose $@
+src/util/padimg.pl --blksize=262144 --byte=0xff --verbose $@
 endef
 
 src/bin-combined/%.efirom: src/bin-i386-pcbios-rom/%.rom src/bin-x86_64-efi-rom/%.efirom

=== debian/tests/control ===
--- 
+++ 
@@ -51,7 +51,6 @@
 Test-Command: ./debian/tests/ipxe-rom i386 e1000
 Depends: ipxe-qemu, expect, xxd, qemu-system-amd64 [amd64 arm64 loong64 mips64el ppc64 ppc64el riscv64 s390x sparc64], qemu-system-i386 [armel armhf i386], seabios, debian-installer-13-netboot-amd64,
 Features: test-name=rom-i386-e1000
-Restrictions: skip-not-installable
 Architecture: amd64,arm64,loong64,mips64el,ppc64,ppc64el,riscv64,s390x,sparc64,armel,armhf,i386
 
 Test-Command: ./debian/tests/ipxe-rom i386 e1000e

=== debian/watch ===
Version: 5
Source: https://github.com/ipxe/ipxe.git
Mode: git
Matching-Pattern: HEAD
Pretty: 1.21.1+git-%cd.%h
RepackSuffix: +dfsg

## ipxe 20110330-1drbl

=== debian/changelog ===
ipxe (20110330-1drbl) unstable; urgency=low

  * New upstream ipxe from git repository on 20110330.

 -- Steven Shiau <steven@nchc.org.tw>  Wed, 30 Mar 2011 15:18:12 +0800

## ipxe 20110509-1drbl

=== src/Makefile ===
###############################################################################
#
# Initialise various variables
#

CLEANUP		:=
CFLAGS		:=
ASFLAGS		:=
LDFLAGS		:=
MAKEDEPS	:= Makefile

###############################################################################
#
# Locations of tools
#
HOST_CC		:= gcc
RM		:= rm -f
TOUCH		:= touch
MKDIR		:= mkdir
CP		:= cp
ECHO		:= echo
PRINTF		:= printf
PERL		:= perl
TRUE		:= true
CC		:= $(CROSS_COMPILE)gcc
CPP		:= $(CC) -E
AS		:= $(CROSS_COMPILE)as
LD		:= $(CROSS_COMPILE)ld
SIZE		:= $(CROSS_COMPILE)size
AR		:= $(CROSS_COMPILE)ar
RANLIB		:= $(CROSS_COMPILE)ranlib
OBJCOPY		:= $(CROSS_COMPILE)objcopy
NM		:= $(CROSS_COMPILE)nm
OBJDUMP		:= $(CROSS_COMPILE)objdump
PARSEROM	:= ./util/parserom.pl
FIXROM		:= ./util/fixrom.pl
SYMCHECK	:= ./util/symcheck.pl
SORTOBJDUMP	:= ./util/sortobjdump.pl
PADIMG		:= ./util/padimg.pl
LICENCE		:= ./util/licence.pl
NRV2B		:= ./util/nrv2b
ZBIN		:= ./util/zbin
ELF2EFI32	:= ./util/elf2efi32
ELF2EFI64	:= ./util/elf2efi64
EFIROM		:= ./util/efirom
ICCFIX		:= ./util/iccfix
EINFO		:= ./util/einfo
GENKEYMAP	:= ./util/genkeymap.pl
DOXYGEN		:= doxygen
BINUTILS_DIR	:= /usr
BFD_DIR		:= $(BINUTILS_DIR)
ZLIB_DIR	:= /usr

###############################################################################
#
# SRCDIRS lists all directories containing source files.
#
SRCDIRS		:=
SRCDIRS		+= libgcc
SRCDIRS		+= core
SRCDIRS		+= net net/tcp net/udp net/infiniband net/80211
SRCDIRS		+= image
SRCDIRS		+= drivers/bus
SRCDIRS		+= drivers/net
SRCDIRS		+= drivers/net/e1000
SRCDIRS		+= drivers/net/e1000e
SRCDIRS		+= drivers/net/igb
SRCDIRS		+= drivers/net/igbvf
SRCDIRS		+= drivers/net/phantom
SRCDIRS		+= drivers/net/rtl818x
SRCDIRS		+= drivers/net/ath5k
SRCDIRS		+= drivers/net/vxge
SRCDIRS		+= drivers/net/efi
SRCDIRS		+= drivers/block
SRCDIRS		+= drivers/nvs
SRCDIRS		+= drivers/bitbash
SRCDIRS		+= drivers/infiniband
SRCDIRS		+= interface/pxe interface/efi interface/smbios
SRCDIRS		+= interface/bofm
SRCDIRS		+= tests
SRCDIRS		+= crypto crypto/axtls crypto/matrixssl
SRCDIRS		+= hci hci/commands hci/tui
SRCDIRS		+= hci/mucurses hci/mucurses/widgets
SRCDIRS		+= hci/keymap
SRCDIRS		+= usr
SRCDIRS		+= config

# NON_AUTO_SRCS lists files that are excluded from the normal
# automatic build system.
#
NON_AUTO_SRCS	:=
NON_AUTO_SRCS	+= drivers/net/prism2.c

# INCDIRS lists the include path
#
INCDIRS		:=
INCDIRS		+= include .

###############################################################################
#
# Default build target: build the most common targets and print out a
# helpfully suggestive message
#
ALL		:= bin/blib.a bin/ipxe.dsk bin/ipxe.lkrn bin/ipxe.iso \
		   bin/ipxe.usb bin/undionly.kpxe bin/rtl8139.rom
all : $(ALL)
	@$(ECHO) '==========================================================='
	@$(ECHO)
	@$(ECHO) 'To create a bootable floppy, type'
	@$(ECHO) '    cat bin/ipxe.dsk > /dev/fd0'
	@$(ECHO) 'where /dev/fd0 is your floppy drive.  This will erase any'
	@$(ECHO) 'data already on the disk.'
	@$(ECHO)
	@$(ECHO) 'To create a bootable USB key, type'
	@$(ECHO) '    cat bin/ipxe.usb > /dev/sdX'
	@$(ECHO) 'where /dev/sdX is your USB key, and is *not* a real hard'
	@$(ECHO) 'disk on your system.  This will erase any data already on'
	@$(ECHO) 'the USB key.'
	@$(ECHO)
	@$(ECHO) 'To create a bootable CD-ROM, burn the ISO image '
	@$(ECHO) 'bin/ipxe.iso to a blank CD-ROM.'
	@$(ECHO)
	@$(ECHO) 'These images contain drivers for all supported cards.  You'
	@$(ECHO) 'can build more customised images, and ROM images, using'
	@$(ECHO) '    make bin/<rom-name>.<output-format>'
	@$(ECHO)
	@$(ECHO) '==========================================================='

###############################################################################
#
# Comprehensive build target: build a selection of cross-platform
# targets to expose potential build errors that show up only on
# certain platforms
#
everything :
	$(Q)$(MAKE) --no-print-directory $(ALL) \
		bin-i386-efi/ipxe.efi bin-i386-efi/ipxe.efidrv \
		bin-i386-efi/ipxe.efirom \
		bin-x86_64-efi/ipxe.efi bin-x86_64-efi/ipxe.efidrv \
		bin-x86_64-efi/ipxe.efirom \
		bin-i386-linux/tap.linux bin-x86_64-linux/tap.linux

###############################################################################
#
# Build targets that do nothing but might be tried by users
#
configure :
	@$(ECHO) "No configuration needed."

install :
	@$(ECHO) "No installation required."

###############################################################################
#
# Version number calculations
#
VERSION_MAJOR	= 1
VERSION_MINOR	= 0
VERSION_PATCH	= 0
EXTRAVERSION	= +
MM_VERSION	= $(VERSION_MAJOR).$(VERSION_MINOR)
VERSION		= $(MM_VERSION).$(VERSION_PATCH)$(EXTRAVERSION)
CFLAGS		+= -DVERSION_MAJOR=$(VERSION_MAJOR) \
		   -DVERSION_MINOR=$(VERSION_MINOR) \
		   -DVERSION_PATCH=$(VERSION_PATCH) \
		   -DVERSION=\"$(VERSION)\"
IDENT		= '$(@F) $(VERSION) (GPL) ipxe.org'
version :
	@$(ECHO) $(VERSION)

###############################################################################
#
# Drag in the bulk of the build system
#

MAKEDEPS	+= Makefile.housekeeping
include Makefile.housekeeping

=== debian/changelog ===
ipxe (20110509-1drbl) unstable; urgency=low

  * New upstream ipxe from git repository on 20110509.

 -- Steven Shiau <steven@nchc.org.tw>  Mon, 09 May 2011 20:59:25 +0800

=== debian/control ===
Source: ipxe
Section: admin
Priority: optional
Maintainer: Steven Shiau <steven@nchc.org.tw>
Build-Depends: debhelper (>> 4.0.0), cdbs, genisoimage, mtools, syslinux, libc6-dev-i386 [amd64]
Standards-Version: 3.7.3

Package: ipxe
Architecture: any
Recommends: mknbi
Description: Open source network boot firmware
 iPXE is the leading open source network boot firmware. It provides a full PXE implementation enhanced with additional features such as:
     boot from a web server via HTTP
     boot from an iSCSI SAN
     boot from a Fibre Channel SAN via FCoE
     boot from an AoE SAN
     boot from a wireless network
     boot from a wide-area network
     boot from an Infiniband network
     control the boot process with a script
 You can use iPXE to replace the existing PXE ROM on your network card, or you can chainload into iPXE to obtain the features of iPXE without the hassle of reflashing.
 iPXE is free, open-source software licensed under the GNU GPL (with some portions under GPL-compatible licences), and is included in products from several network card manufacturers and OEMs. 
 http://ipxe.org

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/makefile.mk

IPXE_MEDIA=dsk iso usb lkrn pxe
DEB_MAKE_INVOKE = $(DEB_MAKE_ENVVARS) make -j 4 -C src/
DEB_MAKE_BUILD_TARGET =  $(patsubst %,bin/ipxe.%,$(IPXE_MEDIA))
DEB_MAKE_INSTALL_TARGET = 

install/ipxe:: build/ipxe
	install -m755 -d debian/$(cdbs_curpkg)/usr/share/ipxe
	for i in dsk iso usb lkrn pxe; do \
		install -m644 src/bin/ipxe.$$i debian/$(cdbs_curpkg)/usr/share/ipxe/; \
	done

## ipxe 20110910-1drbl

=== debian/changelog ===
ipxe (20110910-1drbl) unstable; urgency=low

  * New upstream ipxe from git repository on 20110910.

 -- Steven Shiau <steven@nchc.org.tw>  Sat, 10 Sep 2011 22:08:40 +0800

ipxe (20110811-1drbl) unstable; urgency=low

  * New upstream ipxe from git repository on 20110811.

 -- Steven Shiau <steven@nchc.org.tw>  Thu, 11 Aug 2011 12:01:14 +0800

## ipxe 20111028-1drbl

=== debian/changelog ===
ipxe (20111028-1drbl) unstable; urgency=low

  * New upstream ipxe from git repository on 20111028.

 -- Steven Shiau <steven@nchc.org.tw>  Fri, 28 Oct 2011 09:04:52 +0800

## ipxe 20111212-1drbl

=== debian/changelog ===
ipxe (20111212-1drbl) unstable; urgency=low

  * New upstream from git repository on Nov/12/2011.

 -- Steven Shiau <steven@nchc.org.tw>  Mon, 12 Dec 2011 11:45:56 +0800

## ipxe 20120123-1drbl

=== debian/changelog ===
ipxe (20120123-1drbl) unstable; urgency=low

  * New upstream from git repository on Jan/23/2012.

 -- Steven Shiau <steven@nchc.org.tw>  Mon, 23 Jan 2012 22:01:37 +0800

## ipxe 20120319-1drbl

=== src/Makefile ===
--- 
+++ 
@@ -32,6 +32,7 @@
 OBJCOPY		:= $(CROSS_COMPILE)objcopy
 NM		:= $(CROSS_COMPILE)nm
 OBJDUMP		:= $(CROSS_COMPILE)objdump
+OPENSSL		:= openssl
 PARSEROM	:= ./util/parserom.pl
 FIXROM		:= ./util/fixrom.pl
 SYMCHECK	:= ./util/symcheck.pl
@@ -68,9 +69,12 @@
 SRCDIRS		+= drivers/net/igbvf
 SRCDIRS		+= drivers/net/phantom
 SRCDIRS		+= drivers/net/rtl818x
-SRCDIRS		+= drivers/net/ath5k
+SRCDIRS		+= drivers/net/ath
+SRCDIRS		+= drivers/net/ath/ath5k
+SRCDIRS		+= drivers/net/ath/ath9k
 SRCDIRS		+= drivers/net/vxge
 SRCDIRS		+= drivers/net/efi
+SRCDIRS		+= drivers/net/tg3
 SRCDIRS		+= drivers/block
 SRCDIRS		+= drivers/nvs
 SRCDIRS		+= drivers/bitbash

=== src/arch/i386/Makefile ===
# Force i386-only instructions
#
CFLAGS		+= -march=i386

# Code size reduction.
#
CFLAGS		+= -fomit-frame-pointer

# Code size reduction.
#
ifeq ($(CCTYPE),gcc)
CFLAGS		+= -fstrength-reduce
endif

# Code size reduction.  gcc3 needs a different syntax to gcc2 if you
# want to avoid spurious warnings.
#
ifeq ($(CCTYPE),gcc)
GCC_VERSION	:= $(subst ., ,$(shell $(CC) -dumpversion))
GCC_MAJOR	:= $(firstword $(GCC_VERSION))
ifeq ($(GCC_MAJOR),2)
CFLAGS		+= -malign-jumps=1 -malign-loops=1 -malign-functions=1
else
CFLAGS		+= -falign-jumps=1 -falign-loops=1 -falign-functions=1
endif # gcc2
endif # gcc

# Code size reduction.  This is almost always a win.  The kernel uses
# it, too.
#
ifeq ($(CCTYPE),gcc)
CFLAGS		+= -mpreferred-stack-boundary=2
endif

# Code size reduction.  Use regparm for all functions - C functions
# called from assembly (or vice versa) need __asmcall now
#
CFLAGS		+= -mregparm=3

# Code size reduction.  Use -mrtd (same __asmcall requirements as above)
ifeq ($(CCTYPE),gcc)
CFLAGS		+= -mrtd
endif

# Code size reduction.  This is the logical complement to -mregparm=3.
# It doesn't currently buy us anything, but if anything ever tries to
# return small structures, let's be prepared
#
CFLAGS		+= -freg-struct-return

# Force 32-bit code even on an x86-64 machine
#
CFLAGS		+= -m32
ASFLAGS		+= --32
ifeq ($(HOST_OS),FreeBSD)
LDFLAGS		+= -m elf_i386_fbsd
else
LDFLAGS		+= -m elf_i386
endif

# EFI requires -fshort-wchar, and nothing else currently uses wchar_t
#
CFLAGS		+= -fshort-wchar

# We need to undefine the default macro "i386" when compiling .S
# files, otherwise ".arch i386" translates to ".arch 1"...
#
CFLAGS			+= -Ui386

# Locations of utilities
#
ISOLINUX_BIN_LIST	:= \
	$(ISOLINUX_BIN) \
	/usr/lib/syslinux/isolinux.bin \
	/usr/share/syslinux/isolinux.bin \
	/usr/local/share/syslinux/isolinux.bin
ISOLINUX_BIN	= $(firstword $(wildcard $(ISOLINUX_BIN_LIST)))

# i386-specific directories containing source files
#
SRCDIRS		+= arch/i386/core arch/i386/transitions arch/i386/prefix
SRCDIRS		+= arch/i386/firmware/pcbios
SRCDIRS		+= arch/i386/image
SRCDIRS		+= arch/i386/interface/pcbios
SRCDIRS		+= arch/i386/interface/pxe
SRCDIRS		+= arch/i386/interface/pxeparent
SRCDIRS 	+= arch/i386/interface/syslinux
SRCDIRS		+= arch/i386/interface/vmware
SRCDIRS		+= arch/i386/hci/commands

# The various xxx_loader.c files are #included into core/loader.c and
# should not be compiled directly.
#
NON_AUTO_SRCS	+= arch/i386/core/aout_loader.c
NON_AUTO_SRCS	+= arch/i386/core/freebsd_loader.c
NON_AUTO_SRCS	+= arch/i386/core/wince_loader.c

# Include common x86 Makefile
#
MAKEDEPS	+= arch/x86/Makefile
include arch/x86/Makefile

# Include platform-specific Makefile
#
MAKEDEPS	+= arch/i386/Makefile.$(PLATFORM)
include arch/i386/Makefile.$(PLATFORM)

=== debian/changelog ===
ipxe (20120319-1drbl) unstable; urgency=low

  * New upstream from git repository on Mar/19/2012.

 -- Steven Shiau <steven@nchc.org.tw>  Mon, 19 Mar 2012 10:53:54 +0800

## ipxe 20121012-drbl1

=== src/Makefile ===
--- 
+++ 
@@ -7,6 +7,7 @@
 CFLAGS		:=
 ASFLAGS		:=
 LDFLAGS		:=
+HOST_CFLAGS	:=
 MAKEDEPS	:= Makefile
 
 ###############################################################################
@@ -164,13 +165,17 @@
 EXTRAVERSION	= +
 MM_VERSION	= $(VERSION_MAJOR).$(VERSION_MINOR)
 VERSION		= $(MM_VERSION).$(VERSION_PATCH)$(EXTRAVERSION)
+GITVERSION := $(shell git describe --always --abbrev=1 --match "" 2>/dev/null)
+ifneq ($(GITVERSION),)
+VERSION		+= ($(GITVERSION))
+endif
 CFLAGS		+= -DVERSION_MAJOR=$(VERSION_MAJOR) \
 		   -DVERSION_MINOR=$(VERSION_MINOR) \
 		   -DVERSION_PATCH=$(VERSION_PATCH) \
-		   -DVERSION=\"$(VERSION)\"
+		   -DVERSION="\"$(VERSION)\""
 IDENT		= '$(@F) $(VERSION) (GPL) ipxe.org'
 version :
-	@$(ECHO) $(VERSION)
+	@$(ECHO) "$(VERSION)"
 
 ###############################################################################
 #

=== debian/changelog ===
ipxe (20121012-drbl1) unstable; urgency=low

  * New upstream from git repository on Oct/12/2012.

 -- Steven Shiau <steven@nchc.org.tw>  Fri, 12 Oct 2012 19:34:01 +0800

ipxe (20120726-1drbl) unstable; urgency=low

  * New upstream from git repository on Jul/26/2012.

 -- Steven Shiau <steven@nchc.org.tw>  Thu, 26 Jul 2012 22:36:14 +0800

ipxe (20120618-1drbl) unstable; urgency=low

  * New upstream from git repository on Jun/18/2012.

 -- Steven Shiau <steven@nchc.org.tw>  Mon, 18 Jun 2012 21:51:50 +0800

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Standards-Version: 3.7.3
 
 Package: ipxe
-Architecture: any
+Architecture: all
 Recommends: mknbi
 Description: Open source network boot firmware
  iPXE is the leading open source network boot firmware. It provides a full PXE implementation enhanced with additional features such as:

## ipxe 20121124-drbl1

=== debian/changelog ===
ipxe (20121124-drbl1) unstable; urgency=low

  * New upstream from git repository on Nov/24/2012.

 -- Steven Shiau <steven@nchc.org.tw>  Sat, 24 Nov 2012 08:11:56 +0800

## ipxe 20130424-drbl1

=== src/Makefile ===
--- 
+++ 
@@ -143,7 +143,25 @@
 		bin-i386-efi/ipxe.efirom \
 		bin-x86_64-efi/ipxe.efi bin-x86_64-efi/ipxe.efidrv \
 		bin-x86_64-efi/ipxe.efirom \
-		bin-i386-linux/tap.linux bin-x86_64-linux/tap.linux
+		bin-i386-linux/tap.linux bin-x86_64-linux/tap.linux \
+		bin-i386-linux/tests.linux bin-x86_64-linux/tests.linux
+
+###############################################################################
+#
+# VMware build target: all ROMs used with VMware
+#
+vmware : bin/8086100f.mrom bin/808610d3.mrom bin/10222000.rom bin/15ad07b0.rom
+	@$(ECHO) '==========================================================='
+	@$(ECHO) 
+	@$(ECHO) 'Available ROMs:'
+	@$(ECHO) '    bin/8086100f.mrom -- intel/e1000'
+	@$(ECHO) '    bin/808610d3.mrom -- intel/e1000e'
+	@$(ECHO) '    bin/10222000.rom  -- vlance/pcnet32'
+	@$(ECHO) '    bin/15ad07b0.rom  -- vmxnet3'
+	@$(ECHO) 
+	@$(ECHO) 'For more information, see http://ipxe.org/howto/vmware'
+	@$(ECHO)
+	@$(ECHO) '==========================================================='
 
 ###############################################################################
 #
@@ -169,11 +187,6 @@
 ifneq ($(GITVERSION),)
 VERSION		+= ($(GITVERSION))
 endif
-CFLAGS		+= -DVERSION_MAJOR=$(VERSION_MAJOR) \
-		   -DVERSION_MINOR=$(VERSION_MINOR) \
-		   -DVERSION_PATCH=$(VERSION_PATCH) \
-		   -DVERSION="\"$(VERSION)\""
-IDENT		= '$(@F) $(VERSION) (GPL) ipxe.org'
 version :
 	@$(ECHO) "$(VERSION)"

=== debian/changelog ===
ipxe (20130424-drbl1) unstable; urgency=low

  * New upstream from git repository on Apr/24/2013.

 -- Steven Shiau <steven@nchc.org.tw>  Wed, 24 Apr 2013 21:35:22 +0800

ipxe (20130219-drbl1) unstable; urgency=low

  * New upstream from git repository on Feb/19/2013.

 -- Steven Shiau <steven@nchc.org.tw>  Tue, 19 Feb 2013 20:52:10 +0800

ipxe (20121220-drbl1) unstable; urgency=low

  * New upstream from git repository on Dec/20/2012.

 -- Steven Shiau <steven@nchc.org.tw>  Thu, 20 Dec 2012 15:15:00 +0800

## ipxe 20150114-drbl1

=== debian/changelog ===
ipxe (20150114-drbl1) unstable; urgency=low

  * New upstream from git repository on Jan/14/2015.

 -- Steven Shiau <steven@nchc.org.tw>  Wed, 14 Jan 2015 16:43:07 +0800

ipxe (20140905-drbl1) unstable; urgency=low

  * New upstream from git repository on Sep/05/2014.

 -- Steven Shiau <steven@nchc.org.tw>  Fri, 05 Sep 2014 15:06:12 +0800

ipxe (20140910-drbl1) unstable; urgency=low

  * New upstream from git repository on Sep/10/2014.

 -- Steven Shiau <steven@nchc.org.tw>  Wed, 10 Sep 2014 08:59:50 +0800

ipxe (20131212-drbl1) unstable; urgency=low

  * New upstream from git repository on Dec/12/2013.

 -- Steven Shiau <steven@nchc.org.tw>  Thu, 12 Dec 2013 15:30:23 +0800

ipxe (20131127-drbl1) unstable; urgency=low

  * New upstream from git repository on Nov/27/2013.

 -- Steven Shiau <steven@nchc.org.tw>  Wed, 27 Nov 2013 22:02:34 +0800

ipxe (20131008-drbl1) unstable; urgency=low

  * New upstream from git repository on Oct/08/2013.

 -- Steven Shiau <steven@nchc.org.tw>  Tue, 08 Oct 2013 08:30:05 +0800
